//-----------------------------------------------------------------------------
// Copyright (c) 2013 GarageGames, LLC
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
// IN THE SOFTWARE.
//-----------------------------------------------------------------------------

/*  A Bison parser, made from cmdgram.y with Bison version GNU Bison version 1.24
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse CMDparse
#define yylex CMDlex
#define yyerror CMDerror
#define yylval CMDlval
#define yychar CMDchar
#define yydebug CMDdebug
#define yynerrs CMDnerrs
#define	rwDEFINE	258
#define	rwENDDEF	259
#define	rwDECLARE	260
#define	rwBREAK	261
#define	rwELSE	262
#define	rwCONTINUE	263
#define	rwGLOBAL	264
#define	rwIF	265
#define	rwNIL	266
#define	rwRETURN	267
#define	rwWHILE	268
#define	rwDO	269
#define	rwENDIF	270
#define	rwENDWHILE	271
#define	rwENDFOR	272
#define	rwDEFAULT	273
#define	rwFOR	274
#define	rwDATABLOCK	275
#define	rwSWITCH	276
#define	rwCASE	277
#define	rwSWITCHSTR	278
#define	rwCASEOR	279
#define	rwPACKAGE	280
#define	rwNAMESPACE	281
#define	rwCLASS	282
#define	rwMESSAGE	283
#define	ILLEGAL_TOKEN	284
#define	CHRCONST	285
#define	INTCONST	286
#define	TTAG	287
#define	VAR	288
#define	IDENT	289
#define	DOCBLOCK	290
#define	STRATOM	291
#define	TAGATOM	292
#define	FLTCONST	293
#define	opINTNAME	294
#define	opINTNAMER	295
#define	opMINUSMINUS	296
#define	opPLUSPLUS	297
#define	STMT_SEP	298
#define	opSHL	299
#define	opSHR	300
#define	opPLASN	301
#define	opMIASN	302
#define	opMLASN	303
#define	opDVASN	304
#define	opMODASN	305
#define	opANDASN	306
#define	opXORASN	307
#define	opORASN	308
#define	opSLASN	309
#define	opSRASN	310
#define	opCAT	311
#define	opEQ	312
#define	opNE	313
#define	opGE	314
#define	opLE	315
#define	opAND	316
#define	opOR	317
#define	opSTREQ	318
#define	opCOLONCOLON	319
#define	opMDASN	320
#define	opNDASN	321
#define	opNTASN	322
#define	opSTRNE	323
#define	UNARY	324

#line 1 "cmdgram.y"


// Make sure we don't get gram.h twice.
#define _CMDGRAM_H_

#include <stdlib.h>
#include <stdio.h>
#include "console/console.h"
#include "console/compiler.h"
#include "console/consoleInternal.h"

#ifndef YYDEBUG
#define YYDEBUG 0
#endif

#define YYSSIZE 350

int outtext(char *fmt, ...);
extern int serrors;

#define nil 0
#undef YY_ARGS
#define YY_ARGS(x)   x
 
int CMDlex();
void CMDerror(char *, ...); 

#undef alloca
#define alloca dMalloc

#line 31 "cmdgram.y"

        /* Reserved Word Definitions */
#line 41 "cmdgram.y"

        /* Constants and Identifier Definitions */
#line 54 "cmdgram.y"

        /* Operator Definitions */

#line 67 "cmdgram.y"
typedef union {
   char              c;
   int               i;
   const char *      s;
   char *            str;
   double            f;
   StmtNode *        stmt;
   ExprNode *        expr;
   SlotAssignNode *  slist;
   VarNode *         var;
   SlotDecl          slot;
   InternalSlotDecl  intslot;
   ObjectBlockDecl   odcl;
   ObjectDeclNode *  od;
   AssignDecl        asn;
   IfStmtNode *      ifnode;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		346
#define	YYFLAG		-32768
#define	YYNTBASE	95

#define YYTRANSLATE(x) ((unsigned)(x) <= 324 ? yytranslate[x] : 134)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    59,     2,     2,     2,    49,    48,     2,    50,
    51,    41,    39,    52,    40,    46,    42,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    53,    54,    43,
    45,    44,    91,    60,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    87,     2,    94,    57,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    55,    47,    56,    58,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    61,    62,    63,    64,    65,    66,    67,
    68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    88,
    89,    90,    92,    93
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,     8,    10,    12,    19,    21,    24,
    25,    28,    30,    32,    34,    36,    38,    41,    44,    47,
    51,    54,    59,    66,    68,    77,    88,    89,    91,    93,
    97,   108,   118,   125,   136,   144,   157,   167,   168,   171,
   172,   174,   175,   178,   179,   181,   182,   184,   186,   189,
   192,   196,   200,   202,   210,   218,   223,   231,   237,   239,
   243,   249,   257,   263,   270,   280,   289,   298,   306,   315,
   323,   331,   338,   340,   342,   346,   350,   354,   358,   362,
   366,   370,   374,   378,   381,   384,   386,   392,   396,   400,
   404,   408,   412,   416,   420,   424,   428,   432,   436,   440,
   444,   447,   450,   452,   454,   456,   458,   460,   462,   464,
   466,   468,   473,   477,   484,   488,   492,   494,   498,   500,
   502,   505,   508,   511,   514,   517,   520,   523,   526,   529,
   532,   534,   536,   538,   542,   549,   552,   558,   561,   565,
   571,   576,   583,   590,   591,   593,   595,   599,   601,   604,
   609,   614,   622,   624
};

static const short yyrhs[] = {    96,
     0,     0,    96,    97,     0,   101,     0,   102,     0,    98,
     0,    25,    34,    55,    99,    56,    54,     0,   102,     0,
    99,   102,     0,     0,   100,   101,     0,   118,     0,   119,
     0,   120,     0,   105,     0,   115,     0,     6,    54,     0,
     8,    54,     0,    12,    54,     0,    12,   122,    54,     0,
   121,    54,     0,    32,    45,   122,    54,     0,    32,    45,
   122,    52,   122,    54,     0,    35,     0,     3,    34,    50,
   103,    51,    55,   100,    56,     0,     3,    34,    86,    34,
    50,   103,    51,    55,   100,    56,     0,     0,   104,     0,
    33,     0,   104,    52,    33,     0,    20,    34,    50,    34,
   108,    51,    55,   131,    56,    54,     0,    28,   125,    50,
   109,   108,    51,    55,   111,    56,     0,    28,   125,    50,
   109,   108,    51,     0,     5,   125,    50,   109,   108,   110,
    51,    55,   112,    56,     0,     5,   125,    50,   109,   108,
   110,    51,     0,     5,   125,    50,    87,   109,    94,   108,
   110,    51,    55,   112,    56,     0,     5,   125,    50,    87,
   109,    94,   108,   110,    51,     0,     0,    53,    34,     0,
     0,   122,     0,     0,    52,   130,     0,     0,   131,     0,
     0,   131,     0,   113,     0,   131,   113,     0,   107,    54,
     0,   113,   107,    54,     0,    55,   100,    56,     0,   101,
     0,    21,    50,   122,    51,    55,   116,    56,     0,    23,
    50,   122,    51,    55,   116,    56,     0,    22,   117,    53,
   100,     0,    22,   117,    53,   100,    18,    53,   100,     0,
    22,   117,    53,   100,   116,     0,   122,     0,   117,    24,
   122,     0,    10,    50,   122,    51,   114,     0,    10,    50,
   122,    51,   114,     7,   114,     0,    13,    50,   122,    51,
   114,     0,    14,   114,    13,    50,   122,    51,     0,    19,
    50,   122,    54,   122,    54,   122,    51,   114,     0,    19,
    50,   122,    54,   122,    54,    51,   114,     0,    19,    50,
   122,    54,    54,   122,    51,   114,     0,    19,    50,   122,
    54,    54,    51,   114,     0,    19,    50,    54,   122,    54,
   122,    51,   114,     0,    19,    50,    54,   122,    54,    51,
   114,     0,    19,    50,    54,    54,   122,    51,   114,     0,
    19,    50,    54,    54,    51,   114,     0,   127,     0,   127,
     0,    50,   122,    51,     0,   122,    57,   122,     0,   122,
    49,   122,     0,   122,    48,   122,     0,   122,    47,   122,
     0,   122,    39,   122,     0,   122,    40,   122,     0,   122,
    41,   122,     0,   122,    42,   122,     0,    40,   122,     0,
    41,   122,     0,    32,     0,   122,    91,   122,    53,   122,
     0,   122,    43,   122,     0,   122,    44,   122,     0,   122,
    81,   122,     0,   122,    82,   122,     0,   122,    79,   122,
     0,   122,    80,   122,     0,   122,    84,   122,     0,   122,
    66,   122,     0,   122,    67,   122,     0,   122,    83,   122,
     0,   122,    85,   122,     0,   122,    92,   122,     0,   122,
    60,   122,     0,    59,   122,     0,    58,   122,     0,    37,
     0,    38,     0,    31,     0,     6,     0,   123,     0,   124,
     0,    34,     0,    36,     0,    33,     0,    33,    87,   133,
    94,     0,   122,    46,    34,     0,   122,    46,    34,    87,
   133,    94,     0,   122,    61,   125,     0,   122,    62,   125,
     0,    34,     0,    50,   122,    51,     0,    64,     0,    63,
     0,    68,   122,     0,    69,   122,     0,    70,   122,     0,
    71,   122,     0,    72,   122,     0,    73,   122,     0,    74,
   122,     0,    75,   122,     0,    76,   122,     0,    77,   122,
     0,   128,     0,   107,     0,   106,     0,    33,    45,   122,
     0,    33,    87,   133,    94,    45,   122,     0,    33,   126,
     0,    33,    87,   133,    94,   126,     0,   123,   126,     0,
   123,    45,   122,     0,   123,    45,    55,   130,    56,     0,
    34,    50,   129,    51,     0,    34,    86,    34,    50,   129,
    51,     0,   122,    46,    34,    50,   129,    51,     0,     0,
   130,     0,   122,     0,   130,    52,   122,     0,   132,     0,
   131,   132,     0,    34,    45,   122,    54,     0,    20,    45,
   122,    54,     0,    34,    87,   133,    94,    45,   122,    54,
     0,   122,     0,   133,    52,   122,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   145,   150,   152,   157,   159,   161,   166,   171,   173,   178,
   180,   185,   186,   187,   188,   189,   190,   192,   194,   196,
   198,   200,   202,   204,   209,   211,   216,   218,   223,   225,
   230,   235,   237,   242,   244,   246,   248,   253,   255,   260,
   262,   267,   269,   274,   276,   281,   283,   285,   287,   292,
   294,   299,   301,   306,   308,   313,   315,   317,   322,   324,
   329,   331,   336,   338,   343,   345,   347,   349,   351,   353,
   355,   357,   362,   367,   369,   371,   373,   375,   377,   379,
   381,   383,   385,   387,   389,   391,   393,   395,   397,   399,
   401,   403,   405,   407,   409,   411,   413,   415,   417,   419,
   421,   423,   425,   427,   429,   431,   433,   435,   437,   439,
   441,   443,   448,   450,   455,   457,   462,   464,   469,   471,
   473,   475,   477,   479,   481,   483,   485,   487,   489,   491,
   496,   498,   500,   502,   504,   506,   508,   510,   512,   514,
   519,   521,   523,   528,   530,   535,   537,   542,   544,   549,
   551,   553,   558,   560
};

static const char * const yytname[] = {   "$","error","$undefined.","rwDEFINE",
"rwENDDEF","rwDECLARE","rwBREAK","rwELSE","rwCONTINUE","rwGLOBAL","rwIF","rwNIL",
"rwRETURN","rwWHILE","rwDO","rwENDIF","rwENDWHILE","rwENDFOR","rwDEFAULT","rwFOR",
"rwDATABLOCK","rwSWITCH","rwCASE","rwSWITCHSTR","rwCASEOR","rwPACKAGE","rwNAMESPACE",
"rwCLASS","rwMESSAGE","ILLEGAL_TOKEN","CHRCONST","INTCONST","TTAG","VAR","IDENT",
"DOCBLOCK","STRATOM","TAGATOM","FLTCONST","'+'","'-'","'*'","'/'","'<'","'>'",
"'='","'.'","'|'","'&'","'%'","'('","')'","','","':'","';'","'{'","'}'","'^'",
"'~'","'!'","'@'","opINTNAME","opINTNAMER","opMINUSMINUS","opPLUSPLUS","STMT_SEP",
"opSHL","opSHR","opPLASN","opMIASN","opMLASN","opDVASN","opMODASN","opANDASN",
"opXORASN","opORASN","opSLASN","opSRASN","opCAT","opEQ","opNE","opGE","opLE",
"opAND","opOR","opSTREQ","opCOLONCOLON","'['","opMDASN","opNDASN","opNTASN",
"'?'","opSTRNE","UNARY","']'","start","decl_list","decl","package_decl","fn_decl_list",
"statement_list","stmt","fn_decl_stmt","var_list_decl","var_list","datablock_decl",
"message_decl","object_decl","parent_block","object_name","object_args","message_declare_block",
"object_declare_block","object_decl_list","stmt_block","switch_stmt","case_block",
"case_expr","if_stmt","while_stmt","for_stmt","expression_stmt","expr","slot_acc",
"intslot_acc","class_name_expr","assign_op_struct","stmt_expr","funcall_expr",
"expr_list_decl","expr_list","slot_assign_list","slot_assign","aidx_expr",""
};
#endif

static const short yyr1[] = {     0,
    95,    96,    96,    97,    97,    97,    98,    99,    99,   100,
   100,   101,   101,   101,   101,   101,   101,   101,   101,   101,
   101,   101,   101,   101,   102,   102,   103,   103,   104,   104,
   105,   106,   106,   107,   107,   107,   107,   108,   108,   109,
   109,   110,   110,   111,   111,   112,   112,   112,   112,   113,
   113,   114,   114,   115,   115,   116,   116,   116,   117,   117,
   118,   118,   119,   119,   120,   120,   120,   120,   120,   120,
   120,   120,   121,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   123,   123,   124,   124,   125,   125,   126,   126,
   126,   126,   126,   126,   126,   126,   126,   126,   126,   126,
   127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
   128,   128,   128,   129,   129,   130,   130,   131,   131,   132,
   132,   132,   133,   133
};

static const short yyr2[] = {     0,
     1,     0,     2,     1,     1,     1,     6,     1,     2,     0,
     2,     1,     1,     1,     1,     1,     2,     2,     2,     3,
     2,     4,     6,     1,     8,    10,     0,     1,     1,     3,
    10,     9,     6,    10,     7,    12,     9,     0,     2,     0,
     1,     0,     2,     0,     1,     0,     1,     1,     2,     2,
     3,     3,     1,     7,     7,     4,     7,     5,     1,     3,
     5,     7,     5,     6,     9,     8,     8,     7,     8,     7,
     7,     6,     1,     1,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     2,     2,     1,     5,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     4,     3,     6,     3,     3,     1,     3,     1,     1,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     1,     1,     1,     3,     6,     2,     5,     2,     3,     5,
     4,     6,     6,     0,     1,     1,     3,     1,     2,     4,
     4,     7,     1,     3
};

static const short yydefact[] = {     2,
     1,     0,     0,   106,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   105,    86,   111,   109,    24,
   110,   103,   104,     0,     0,     0,     0,     0,     3,     6,
     4,     5,    15,   133,   132,    16,    12,    13,    14,     0,
     0,   107,   108,    74,   131,     0,   117,     0,     0,    17,
    18,     0,   106,    86,    19,     0,    74,     0,    10,    53,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   120,
   119,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   136,   144,     0,    84,    85,     0,   102,   101,
    21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   138,    27,     0,
     0,    40,     0,    20,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    40,     0,   134,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   153,     0,   146,     0,
   145,     0,    75,    80,    81,    82,    83,    88,    89,   113,
    79,    78,    77,    76,   100,   115,   116,    95,    96,    92,
    93,    90,    91,    97,    94,    98,     0,    99,     0,   139,
    29,     0,    28,     0,   118,    40,    38,    41,     0,     0,
    52,    11,     0,     0,     0,     0,    38,     0,     0,     0,
     8,    38,     0,    22,     0,   112,   141,     0,   144,   144,
     0,     0,     0,     0,     0,    27,     0,     0,    42,    61,
    63,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     9,     0,     0,   154,     0,   137,   147,     0,     0,
     0,    87,   140,    10,    30,     0,    38,    39,     0,     0,
     0,    64,    72,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     7,    33,    23,   135,   142,   143,   114,
     0,     0,    42,    43,    35,    62,    71,    70,     0,    68,
     0,     0,     0,     0,     0,    59,    54,    55,    44,    25,
    10,     0,    46,    69,    67,    66,     0,     0,     0,     0,
   148,     0,    10,     0,    45,     0,    37,     0,     0,    48,
    47,    65,     0,     0,     0,     0,   149,    60,    56,    32,
    26,    46,    50,    34,     0,    49,     0,     0,     0,    31,
     0,    58,     0,    51,   151,   150,     0,    10,    36,     0,
    57,     0,   152,     0,     0,     0
};

static const short yydefgoto[] = {   344,
     1,    29,    30,   200,   126,    60,    32,   182,   183,    33,
    34,    35,   219,   187,   250,   304,   309,   310,    61,    36,
   262,   285,    37,    38,    39,    40,    41,    42,    43,    49,
    83,    57,    45,   150,   151,   311,   301,   148
};

static const short yypact[] = {-32768,
   109,   -11,    56,   -24,   -21,    -9,   414,    -7,   403,    -2,
    21,    36,    47,    73,    56,-32768,    65,   252,   -35,-32768,
-32768,-32768,-32768,   949,   949,   949,   949,   949,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    66,
  2104,  2299,-32768,    81,-32768,     6,-32768,   949,   101,-32768,
-32768,   949,-32768,-32768,-32768,  1024,-32768,   949,-32768,-32768,
   139,   701,   108,   949,   949,   106,   120,   949,   949,-32768,
-32768,   949,   949,   949,   949,   949,   949,   949,   949,   949,
   949,   949,-32768,   949,   130,   111,   111,  1078,   111,   111,
-32768,   949,   949,   949,   949,   949,   949,   137,   949,   949,
   949,   949,   949,    56,    56,   949,   949,   949,   949,   949,
   949,   949,   949,   949,   949,   949,   712,-32768,   141,   143,
  1132,    44,  1186,-32768,  1240,   494,   132,   751,  1294,   146,
  1348,  1402,   181,   949,   970,  2104,  2104,  2104,  2104,  2104,
  2104,  2104,  2104,  2104,  2104,  2104,  2104,   -42,  2104,   147,
   138,   149,-32768,   114,   114,   111,   111,   515,   515,   -34,
  2216,  2274,   111,  2245,  2354,-32768,-32768,   178,   178,   202,
   202,   515,   515,  2187,  2158,  2354,  1456,  2354,   949,  2104,
-32768,   151,   145,   150,-32768,   949,   159,  2104,   403,   403,
-32768,-32768,   949,   788,  1510,   825,   159,   148,   160,    11,
-32768,   159,   949,-32768,   949,  2315,-32768,   949,   949,   949,
   949,   949,    52,   161,   188,   141,   131,   192,   176,   222,
-32768,  1564,   403,  1618,   836,   875,  1672,   179,   211,   211,
   180,-32768,   184,  1726,  2104,   949,-32768,  2104,   185,   186,
   -20,   -22,-32768,-32768,-32768,   187,   159,-32768,   949,   196,
   403,-32768,-32768,   403,   403,  1780,   403,  1834,   912,   194,
   949,   199,   201,-32768,   197,-32768,  2104,-32768,-32768,-32768,
   582,   203,   176,   138,   204,-32768,-32768,-32768,   403,-32768,
   403,   403,  1888,     8,    63,  2104,-32768,-32768,     8,-32768,
-32768,   209,   128,-32768,-32768,-32768,   403,   216,     1,    71,
-32768,   949,-32768,   210,     8,   623,   212,   218,   217,   260,
   128,-32768,   949,   949,   949,   220,-32768,  2104,   173,-32768,
-32768,   128,-32768,-32768,   221,   260,  1942,  1996,    -5,-32768,
   223,-32768,   226,-32768,-32768,-32768,   232,-32768,-32768,   949,
   664,  2050,-32768,   279,   285,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,  -237,     0,  -127,    70,-32768,-32768,
-32768,  -157,  -168,  -122,    15,-32768,   -33,   -19,  -186,-32768,
  -219,-32768,-32768,-32768,-32768,-32768,   284,-32768,-32768,    -6,
   -40,    -1,-32768,   -71,  -166,  -253,  -187,  -206
};


#define	YYLAST		2421


static const short yytable[] = {    44,
    31,   118,   220,   221,   241,   201,   271,    44,    67,   205,
   263,   202,   213,     2,    84,   210,    92,    93,    94,    95,
    96,    97,    46,    98,    99,   100,   101,   298,   228,    50,
   300,   205,    51,   233,   102,   305,   253,   103,   104,   105,
    52,   299,    58,   106,   107,   314,   205,    62,     3,    53,
    85,   206,   211,   306,    63,   119,   108,   109,   110,   111,
   112,   113,   114,   217,   276,   319,   231,   277,   278,   116,
   280,    15,   232,   270,    16,    54,    18,    19,   273,    21,
    22,    23,   274,    24,    25,    64,   302,   315,   337,    47,
   298,   120,   294,    26,   295,   296,    65,   166,   167,   332,
   341,    27,    28,   208,   299,    48,    66,   243,   329,    68,
   312,     2,   317,     3,     4,   303,     5,   317,     6,    91,
     7,     8,     9,   317,    44,   192,   316,    10,    11,    12,
   186,    13,     3,    14,   -73,   308,    15,   239,   240,    16,
    17,    18,    19,    20,    21,    22,    23,   298,    24,    25,
   122,   127,   325,   308,    94,    95,    98,   130,    26,    98,
   133,   299,   101,   152,   308,   237,    27,    28,   325,   134,
   160,   104,   105,   181,   104,   105,   184,     3,     4,   197,
     5,   193,     6,     2,     7,     8,     9,    44,    44,   208,
   331,    10,    11,    12,   261,    13,   215,   207,   209,   216,
    15,   214,   229,    16,    17,    18,    19,    20,    21,    22,
    23,   218,    24,    25,   230,   244,    92,    93,    94,    95,
   245,    44,    26,    98,   247,   248,   101,   249,   251,   260,
    27,    28,   261,   264,   265,   268,   269,   272,   104,   105,
    92,    93,    94,    95,    96,    97,   275,    98,   284,    44,
   101,   289,    44,    44,   287,    44,   288,   291,   293,   307,
   313,   103,   104,   105,     3,   320,   322,   106,   107,    44,
   192,   323,   324,   330,   334,   338,   340,    44,   345,    44,
    44,   339,   110,   111,   346,   246,   114,   292,   333,     0,
    56,   326,     0,   116,     0,    44,    69,     0,     0,     0,
     0,     0,     0,     0,    44,   192,     0,    86,    87,    88,
    89,    90,     0,     0,    70,    71,     0,    44,   192,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
     0,   121,     0,     0,     0,   123,     0,     0,    82,    44,
   192,   125,     0,     0,     0,   129,     0,   131,   132,     0,
     0,   135,   136,     0,     0,   137,   138,   139,   140,   141,
   142,   143,   144,   145,   146,   147,     0,   149,     0,     0,
     0,     0,     0,     0,     0,   154,   155,   156,   157,   158,
   159,     0,   161,   162,   163,   164,   165,     0,     0,   168,
   169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
   180,     0,     0,     0,     0,   188,     0,     3,     4,     0,
     5,   195,     6,     0,     7,     8,     9,   188,     3,    53,
     0,    10,    11,    12,     0,    13,     0,     0,     0,     0,
    15,     0,     0,    16,    17,    18,    19,    20,    21,    22,
    23,    15,    24,    25,    16,    54,    18,    19,     0,    21,
    22,    23,    26,    24,    25,     0,     0,    59,     0,     0,
    27,    28,   149,    26,     0,     0,     0,    55,     0,   188,
     0,    27,    28,     0,     0,     0,   222,   224,     0,   227,
     0,     0,     0,     0,     0,     0,   234,     0,   235,     0,
     0,   238,   149,   149,   147,   242,     0,     0,     3,     4,
     0,     5,     0,     6,     0,     7,     8,     9,   256,   258,
     0,     0,    10,    11,    12,     0,    13,     0,     0,   267,
     0,    15,     0,     0,    16,    17,    18,    19,    20,    21,
    22,    23,   149,    24,    25,     0,     0,     0,     0,     0,
     0,     0,   283,    26,   286,     0,     0,     0,     0,   191,
     0,    27,    28,    92,    93,    94,    95,     0,     0,     0,
    98,     0,     0,   101,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   103,   104,   105,     0,     0,     0,
   106,   107,     0,     0,     0,   318,     3,     4,     0,     5,
     0,     6,     0,     7,     8,     9,   327,   328,   147,   114,
    10,    11,    12,     0,    13,     0,   116,     0,     0,    15,
     0,     0,    16,    17,    18,    19,    20,    21,    22,    23,
     0,    24,    25,   342,     0,     0,     0,     3,     4,     0,
     5,    26,     6,     0,     7,     8,     9,   290,     0,    27,
    28,    10,    11,    12,     0,    13,     0,     0,     0,     0,
    15,     0,     0,    16,    17,    18,    19,    20,    21,    22,
    23,     0,    24,    25,     0,     0,     0,     0,     3,     4,
     0,     5,    26,     6,     0,     7,     8,     9,   321,     0,
    27,    28,    10,    11,    12,     0,    13,     0,     0,     0,
     0,    15,     0,     0,    16,    17,    18,    19,    20,    21,
    22,    23,     0,    24,    25,     3,    53,     0,     0,     0,
     0,     0,     0,    26,     0,     0,     3,    53,     0,     0,
     0,    27,    28,     0,     0,     0,     0,     0,    15,     0,
     0,    16,    54,    18,    19,     0,    21,    22,    23,    15,
    24,    25,    16,    54,    18,    19,     0,    21,    22,    23,
    26,    24,    25,     0,   128,     3,    53,     0,    27,    28,
     0,    26,     0,     0,     0,     0,   179,     0,     0,    27,
    28,     0,     0,     0,     0,     0,     0,     0,    15,     0,
     0,    16,    54,    18,    19,     0,    21,    22,    23,     0,
    24,    25,     3,    53,     0,     0,     0,     0,     0,     0,
    26,     0,     0,     0,   194,     0,     0,     0,    27,    28,
     0,     0,     0,     0,     0,    15,     0,     0,    16,    54,
    18,    19,     0,    21,    22,    23,     0,    24,    25,     3,
    53,     0,     0,     0,     0,     0,     0,    26,   223,     0,
     3,    53,     0,     0,     0,    27,    28,     0,     0,     0,
     0,     0,    15,     0,     0,    16,    54,    18,    19,     0,
    21,    22,    23,    15,    24,    25,    16,    54,    18,    19,
     0,    21,    22,    23,    26,    24,    25,     0,   226,     3,
    53,     0,    27,    28,     0,    26,   255,     0,     0,     0,
     0,     0,     0,    27,    28,     0,     0,     0,     0,     0,
     0,     0,    15,     0,     0,    16,    54,    18,    19,     0,
    21,    22,    23,     0,    24,    25,     3,    53,     0,     0,
     0,     0,     0,     0,    26,   257,     0,     0,     0,     0,
     0,     0,    27,    28,     0,     0,     0,     0,     0,    15,
     0,     0,    16,    54,    18,    19,     0,    21,    22,    23,
     0,    24,    25,     3,    53,     0,     0,     0,     0,     0,
     0,    26,   282,     0,     0,     0,     0,     0,     0,    27,
    28,     0,     0,     0,     0,     0,    15,     0,     0,    16,
    54,    18,    19,     0,    21,    22,    23,     0,    24,    25,
     0,     0,     0,     0,     0,     0,     0,     0,    26,     0,
     0,     0,     0,     0,     0,     0,    27,    28,    92,    93,
    94,    95,    96,    97,     0,    98,    99,   100,   101,     0,
     0,   203,     0,   204,     0,     0,   102,     0,     0,   103,
   104,   105,     0,     0,     0,   106,   107,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   108,   109,
   110,   111,   112,   113,   114,     0,     0,     0,     0,     0,
   115,   116,    92,    93,    94,    95,    96,    97,     0,    98,
    99,   100,   101,     0,     0,     0,     0,   124,     0,     0,
   102,     0,     0,   103,   104,   105,     0,     0,     0,   106,
   107,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   108,   109,   110,   111,   112,   113,   114,     0,
     0,     0,     0,     0,   115,   116,    92,    93,    94,    95,
    96,    97,     0,    98,    99,   100,   101,     0,   153,     0,
     0,     0,     0,     0,   102,     0,     0,   103,   104,   105,
     0,     0,     0,   106,   107,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   108,   109,   110,   111,
   112,   113,   114,     0,     0,     0,     0,     0,   115,   116,
    92,    93,    94,    95,    96,    97,     0,    98,    99,   100,
   101,     0,   185,     0,     0,     0,     0,     0,   102,     0,
     0,   103,   104,   105,     0,     0,     0,   106,   107,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   108,   109,   110,   111,   112,   113,   114,     0,     0,     0,
     0,     0,   115,   116,    92,    93,    94,    95,    96,    97,
     0,    98,    99,   100,   101,     0,   189,     0,     0,     0,
     0,     0,   102,     0,     0,   103,   104,   105,     0,     0,
     0,   106,   107,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   108,   109,   110,   111,   112,   113,
   114,     0,     0,     0,     0,     0,   115,   116,    92,    93,
    94,    95,    96,    97,     0,    98,    99,   100,   101,     0,
   190,     0,     0,     0,     0,     0,   102,     0,     0,   103,
   104,   105,     0,     0,     0,   106,   107,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   108,   109,
   110,   111,   112,   113,   114,     0,     0,     0,     0,     0,
   115,   116,    92,    93,    94,    95,    96,    97,     0,    98,
    99,   100,   101,     0,     0,     0,     0,   196,     0,     0,
   102,     0,     0,   103,   104,   105,     0,     0,     0,   106,
   107,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   108,   109,   110,   111,   112,   113,   114,     0,
     0,     0,     0,     0,   115,   116,    92,    93,    94,    95,
    96,    97,     0,    98,    99,   100,   101,     0,   198,     0,
     0,     0,     0,     0,   102,     0,     0,   103,   104,   105,
     0,     0,     0,   106,   107,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   108,   109,   110,   111,
   112,   113,   114,     0,     0,     0,     0,     0,   115,   116,
    92,    93,    94,    95,    96,    97,     0,    98,    99,   100,
   101,     0,   199,     0,     0,     0,     0,     0,   102,     0,
     0,   103,   104,   105,     0,     0,     0,   106,   107,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   108,   109,   110,   111,   112,   113,   114,     0,     0,     0,
     0,     0,   115,   116,    92,    93,    94,    95,    96,    97,
     0,    98,    99,   100,   101,     0,     0,     0,   212,     0,
     0,     0,   102,     0,     0,   103,   104,   105,     0,     0,
     0,   106,   107,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   108,   109,   110,   111,   112,   113,
   114,     0,     0,     0,     0,     0,   115,   116,    92,    93,
    94,    95,    96,    97,     0,    98,    99,   100,   101,     0,
     0,     0,     0,   225,     0,     0,   102,     0,     0,   103,
   104,   105,     0,     0,     0,   106,   107,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   108,   109,
   110,   111,   112,   113,   114,     0,     0,     0,     0,     0,
   115,   116,    92,    93,    94,    95,    96,    97,     0,    98,
    99,   100,   101,     0,   252,     0,     0,     0,     0,     0,
   102,     0,     0,   103,   104,   105,     0,     0,     0,   106,
   107,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   108,   109,   110,   111,   112,   113,   114,     0,
     0,     0,     0,     0,   115,   116,    92,    93,    94,    95,
    96,    97,     0,    98,    99,   100,   101,     0,   254,     0,
     0,     0,     0,     0,   102,     0,     0,   103,   104,   105,
     0,     0,     0,   106,   107,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   108,   109,   110,   111,
   112,   113,   114,     0,     0,     0,     0,     0,   115,   116,
    92,    93,    94,    95,    96,    97,     0,    98,    99,   100,
   101,     0,     0,     0,     0,   259,     0,     0,   102,     0,
     0,   103,   104,   105,     0,     0,     0,   106,   107,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   108,   109,   110,   111,   112,   113,   114,     0,     0,     0,
     0,     0,   115,   116,    92,    93,    94,    95,    96,    97,
     0,    98,    99,   100,   101,     0,     0,     0,     0,   266,
     0,     0,   102,     0,     0,   103,   104,   105,     0,     0,
     0,   106,   107,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   108,   109,   110,   111,   112,   113,
   114,     0,     0,     0,     0,     0,   115,   116,    92,    93,
    94,    95,    96,    97,     0,    98,    99,   100,   101,     0,
   279,     0,     0,     0,     0,     0,   102,     0,     0,   103,
   104,   105,     0,     0,     0,   106,   107,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   108,   109,
   110,   111,   112,   113,   114,     0,     0,     0,     0,     0,
   115,   116,    92,    93,    94,    95,    96,    97,     0,    98,
    99,   100,   101,     0,   281,     0,     0,     0,     0,     0,
   102,     0,     0,   103,   104,   105,     0,     0,     0,   106,
   107,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   108,   109,   110,   111,   112,   113,   114,     0,
     0,     0,     0,     0,   115,   116,    92,    93,    94,    95,
    96,    97,     0,    98,    99,   100,   101,     0,   297,     0,
     0,     0,     0,     0,   102,     0,     0,   103,   104,   105,
     0,     0,     0,   106,   107,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   108,   109,   110,   111,
   112,   113,   114,     0,     0,     0,     0,     0,   115,   116,
    92,    93,    94,    95,    96,    97,     0,    98,    99,   100,
   101,     0,     0,     0,     0,   335,     0,     0,   102,     0,
     0,   103,   104,   105,     0,     0,     0,   106,   107,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   108,   109,   110,   111,   112,   113,   114,     0,     0,     0,
     0,     0,   115,   116,    92,    93,    94,    95,    96,    97,
     0,    98,    99,   100,   101,     0,     0,     0,     0,   336,
     0,     0,   102,     0,     0,   103,   104,   105,     0,     0,
     0,   106,   107,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   108,   109,   110,   111,   112,   113,
   114,     0,     0,     0,     0,     0,   115,   116,    92,    93,
    94,    95,    96,    97,     0,    98,    99,   100,   101,     0,
     0,     0,     0,   343,     0,     0,   102,     0,     0,   103,
   104,   105,     0,     0,     0,   106,   107,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   108,   109,
   110,   111,   112,   113,   114,     0,     0,     0,     0,     0,
   115,   116,    92,    93,    94,    95,    96,    97,     0,    98,
    99,   100,   101,     0,     0,     0,     0,     0,     0,     0,
   102,     0,     0,   103,   104,   105,     0,     0,     0,   106,
   107,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   108,   109,   110,   111,   112,   113,   114,     0,
     0,     0,     0,     0,   115,   116,    92,    93,    94,    95,
    96,    97,     0,    98,    99,   100,   101,     0,     0,     0,
     0,     0,     0,     0,   102,     0,     0,   103,   104,   105,
     0,     0,     0,   106,   107,    92,    93,    94,    95,    96,
    97,     0,    98,    99,   100,   101,   108,   109,   110,   111,
   112,     0,   114,   102,     0,     0,   103,   104,   105,   116,
     0,     0,   106,   107,    92,    93,    94,    95,    96,    97,
     0,    98,     0,   100,   101,   108,   109,   110,   111,     0,
     0,   114,   102,     0,     0,   103,   104,   105,   116,     0,
     0,   106,   107,    92,    93,    94,    95,    96,    97,     0,
    98,     0,   100,   101,   108,   109,   110,   111,     0,     0,
   114,     0,     0,     0,   103,   104,   105,   116,     0,     0,
   106,   107,    92,    93,    94,    95,    96,    97,     0,    98,
     0,     0,   101,   108,   109,   110,   111,     0,     0,   114,
     0,     0,     0,   103,   104,   105,   116,     0,     0,   106,
   107,     0,     0,   117,     0,     0,     0,     0,     0,     0,
     0,     0,   108,   109,   110,   111,     0,     0,   114,   236,
     0,    70,    71,     0,     0,   116,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,     0,    70,    71,     0,
     0,     0,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    92,    93,    94,    95,     0,     0,     0,    98,
     0,     0,   101,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   104,   105,     0,     0,     0,   106,
   107
};

static const short yycheck[] = {     1,
     1,    42,   189,   190,   211,   133,   244,     9,    15,    52,
   230,   134,   179,     3,    50,    50,    39,    40,    41,    42,
    43,    44,    34,    46,    47,    48,    49,    20,   197,    54,
   284,    52,    54,   202,    57,   289,   223,    60,    61,    62,
    50,    34,    50,    66,    67,    45,    52,    50,     5,     6,
    86,    94,    87,   291,    34,    50,    79,    80,    81,    82,
    83,    84,    85,   186,   251,   303,    56,   254,   255,    92,
   257,    28,   200,    94,    31,    32,    33,    34,   247,    36,
    37,    38,   249,    40,    41,    50,    24,    87,    94,    34,
    20,    86,   279,    50,   281,   282,    50,   104,   105,   319,
   338,    58,    59,    52,    34,    50,    34,    56,   315,    45,
   297,     3,   300,     5,     6,    53,     8,   305,    10,    54,
    12,    13,    14,   311,   126,   126,    56,    19,    20,    21,
    87,    23,     5,    25,    54,   293,    28,   209,   210,    31,
    32,    33,    34,    35,    36,    37,    38,    20,    40,    41,
    50,    13,   310,   311,    41,    42,    46,    50,    50,    46,
    55,    34,    49,    34,   322,   206,    58,    59,   326,    50,
    34,    61,    62,    33,    61,    62,    34,     5,     6,    34,
     8,    50,    10,     3,    12,    13,    14,   189,   190,    52,
    18,    19,    20,    21,    22,    23,    52,    51,    50,    50,
    28,    51,    55,    31,    32,    33,    34,    35,    36,    37,
    38,    53,    40,    41,    55,    55,    39,    40,    41,    42,
    33,   223,    50,    46,    94,    34,    49,    52,     7,    51,
    58,    59,    22,    54,    51,    51,    51,    51,    61,    62,
    39,    40,    41,    42,    43,    44,    51,    46,    55,   251,
    49,    55,   254,   255,    56,   257,    56,    55,    55,    51,
    45,    60,    61,    62,     5,    56,    55,    66,    67,   271,
   271,    54,    56,    54,    54,    53,    45,   279,     0,   281,
   282,    56,    81,    82,     0,   216,    85,   273,   322,    -1,
     7,   311,    -1,    92,    -1,   297,    45,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   306,   306,    -1,    24,    25,    26,
    27,    28,    -1,    -1,    63,    64,    -1,   319,   319,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
    -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    87,   341,
   341,    58,    -1,    -1,    -1,    62,    -1,    64,    65,    -1,
    -1,    68,    69,    -1,    -1,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    -1,    84,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    92,    93,    94,    95,    96,
    97,    -1,    99,   100,   101,   102,   103,    -1,    -1,   106,
   107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
   117,    -1,    -1,    -1,    -1,   122,    -1,     5,     6,    -1,
     8,   128,    10,    -1,    12,    13,    14,   134,     5,     6,
    -1,    19,    20,    21,    -1,    23,    -1,    -1,    -1,    -1,
    28,    -1,    -1,    31,    32,    33,    34,    35,    36,    37,
    38,    28,    40,    41,    31,    32,    33,    34,    -1,    36,
    37,    38,    50,    40,    41,    -1,    -1,    55,    -1,    -1,
    58,    59,   179,    50,    -1,    -1,    -1,    54,    -1,   186,
    -1,    58,    59,    -1,    -1,    -1,   193,   194,    -1,   196,
    -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,   205,    -1,
    -1,   208,   209,   210,   211,   212,    -1,    -1,     5,     6,
    -1,     8,    -1,    10,    -1,    12,    13,    14,   225,   226,
    -1,    -1,    19,    20,    21,    -1,    23,    -1,    -1,   236,
    -1,    28,    -1,    -1,    31,    32,    33,    34,    35,    36,
    37,    38,   249,    40,    41,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   259,    50,   261,    -1,    -1,    -1,    -1,    56,
    -1,    58,    59,    39,    40,    41,    42,    -1,    -1,    -1,
    46,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,
    66,    67,    -1,    -1,    -1,   302,     5,     6,    -1,     8,
    -1,    10,    -1,    12,    13,    14,   313,   314,   315,    85,
    19,    20,    21,    -1,    23,    -1,    92,    -1,    -1,    28,
    -1,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
    -1,    40,    41,   340,    -1,    -1,    -1,     5,     6,    -1,
     8,    50,    10,    -1,    12,    13,    14,    56,    -1,    58,
    59,    19,    20,    21,    -1,    23,    -1,    -1,    -1,    -1,
    28,    -1,    -1,    31,    32,    33,    34,    35,    36,    37,
    38,    -1,    40,    41,    -1,    -1,    -1,    -1,     5,     6,
    -1,     8,    50,    10,    -1,    12,    13,    14,    56,    -1,
    58,    59,    19,    20,    21,    -1,    23,    -1,    -1,    -1,
    -1,    28,    -1,    -1,    31,    32,    33,    34,    35,    36,
    37,    38,    -1,    40,    41,     5,     6,    -1,    -1,    -1,
    -1,    -1,    -1,    50,    -1,    -1,     5,     6,    -1,    -1,
    -1,    58,    59,    -1,    -1,    -1,    -1,    -1,    28,    -1,
    -1,    31,    32,    33,    34,    -1,    36,    37,    38,    28,
    40,    41,    31,    32,    33,    34,    -1,    36,    37,    38,
    50,    40,    41,    -1,    54,     5,     6,    -1,    58,    59,
    -1,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    58,
    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
    -1,    31,    32,    33,    34,    -1,    36,    37,    38,    -1,
    40,    41,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,
    50,    -1,    -1,    -1,    54,    -1,    -1,    -1,    58,    59,
    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    31,    32,
    33,    34,    -1,    36,    37,    38,    -1,    40,    41,     5,
     6,    -1,    -1,    -1,    -1,    -1,    -1,    50,    51,    -1,
     5,     6,    -1,    -1,    -1,    58,    59,    -1,    -1,    -1,
    -1,    -1,    28,    -1,    -1,    31,    32,    33,    34,    -1,
    36,    37,    38,    28,    40,    41,    31,    32,    33,    34,
    -1,    36,    37,    38,    50,    40,    41,    -1,    54,     5,
     6,    -1,    58,    59,    -1,    50,    51,    -1,    -1,    -1,
    -1,    -1,    -1,    58,    59,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    28,    -1,    -1,    31,    32,    33,    34,    -1,
    36,    37,    38,    -1,    40,    41,     5,     6,    -1,    -1,
    -1,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
    -1,    -1,    58,    59,    -1,    -1,    -1,    -1,    -1,    28,
    -1,    -1,    31,    32,    33,    34,    -1,    36,    37,    38,
    -1,    40,    41,     5,     6,    -1,    -1,    -1,    -1,    -1,
    -1,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    58,
    59,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    31,
    32,    33,    34,    -1,    36,    37,    38,    -1,    40,    41,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    58,    59,    39,    40,
    41,    42,    43,    44,    -1,    46,    47,    48,    49,    -1,
    -1,    52,    -1,    54,    -1,    -1,    57,    -1,    -1,    60,
    61,    62,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
    81,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
    91,    92,    39,    40,    41,    42,    43,    44,    -1,    46,
    47,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
    57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,
    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    82,    83,    84,    85,    -1,
    -1,    -1,    -1,    -1,    91,    92,    39,    40,    41,    42,
    43,    44,    -1,    46,    47,    48,    49,    -1,    51,    -1,
    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,    62,
    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
    83,    84,    85,    -1,    -1,    -1,    -1,    -1,    91,    92,
    39,    40,    41,    42,    43,    44,    -1,    46,    47,    48,
    49,    -1,    51,    -1,    -1,    -1,    -1,    -1,    57,    -1,
    -1,    60,    61,    62,    -1,    -1,    -1,    66,    67,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    79,    80,    81,    82,    83,    84,    85,    -1,    -1,    -1,
    -1,    -1,    91,    92,    39,    40,    41,    42,    43,    44,
    -1,    46,    47,    48,    49,    -1,    51,    -1,    -1,    -1,
    -1,    -1,    57,    -1,    -1,    60,    61,    62,    -1,    -1,
    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
    85,    -1,    -1,    -1,    -1,    -1,    91,    92,    39,    40,
    41,    42,    43,    44,    -1,    46,    47,    48,    49,    -1,
    51,    -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,
    61,    62,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
    81,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
    91,    92,    39,    40,    41,    42,    43,    44,    -1,    46,
    47,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
    57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,
    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    82,    83,    84,    85,    -1,
    -1,    -1,    -1,    -1,    91,    92,    39,    40,    41,    42,
    43,    44,    -1,    46,    47,    48,    49,    -1,    51,    -1,
    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,    62,
    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
    83,    84,    85,    -1,    -1,    -1,    -1,    -1,    91,    92,
    39,    40,    41,    42,    43,    44,    -1,    46,    47,    48,
    49,    -1,    51,    -1,    -1,    -1,    -1,    -1,    57,    -1,
    -1,    60,    61,    62,    -1,    -1,    -1,    66,    67,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    79,    80,    81,    82,    83,    84,    85,    -1,    -1,    -1,
    -1,    -1,    91,    92,    39,    40,    41,    42,    43,    44,
    -1,    46,    47,    48,    49,    -1,    -1,    -1,    53,    -1,
    -1,    -1,    57,    -1,    -1,    60,    61,    62,    -1,    -1,
    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
    85,    -1,    -1,    -1,    -1,    -1,    91,    92,    39,    40,
    41,    42,    43,    44,    -1,    46,    47,    48,    49,    -1,
    -1,    -1,    -1,    54,    -1,    -1,    57,    -1,    -1,    60,
    61,    62,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
    81,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
    91,    92,    39,    40,    41,    42,    43,    44,    -1,    46,
    47,    48,    49,    -1,    51,    -1,    -1,    -1,    -1,    -1,
    57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,
    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    82,    83,    84,    85,    -1,
    -1,    -1,    -1,    -1,    91,    92,    39,    40,    41,    42,
    43,    44,    -1,    46,    47,    48,    49,    -1,    51,    -1,
    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,    62,
    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
    83,    84,    85,    -1,    -1,    -1,    -1,    -1,    91,    92,
    39,    40,    41,    42,    43,    44,    -1,    46,    47,    48,
    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    57,    -1,
    -1,    60,    61,    62,    -1,    -1,    -1,    66,    67,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    79,    80,    81,    82,    83,    84,    85,    -1,    -1,    -1,
    -1,    -1,    91,    92,    39,    40,    41,    42,    43,    44,
    -1,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    54,
    -1,    -1,    57,    -1,    -1,    60,    61,    62,    -1,    -1,
    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
    85,    -1,    -1,    -1,    -1,    -1,    91,    92,    39,    40,
    41,    42,    43,    44,    -1,    46,    47,    48,    49,    -1,
    51,    -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,
    61,    62,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
    81,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
    91,    92,    39,    40,    41,    42,    43,    44,    -1,    46,
    47,    48,    49,    -1,    51,    -1,    -1,    -1,    -1,    -1,
    57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,
    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    82,    83,    84,    85,    -1,
    -1,    -1,    -1,    -1,    91,    92,    39,    40,    41,    42,
    43,    44,    -1,    46,    47,    48,    49,    -1,    51,    -1,
    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,    62,
    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
    83,    84,    85,    -1,    -1,    -1,    -1,    -1,    91,    92,
    39,    40,    41,    42,    43,    44,    -1,    46,    47,    48,
    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    57,    -1,
    -1,    60,    61,    62,    -1,    -1,    -1,    66,    67,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    79,    80,    81,    82,    83,    84,    85,    -1,    -1,    -1,
    -1,    -1,    91,    92,    39,    40,    41,    42,    43,    44,
    -1,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    54,
    -1,    -1,    57,    -1,    -1,    60,    61,    62,    -1,    -1,
    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
    85,    -1,    -1,    -1,    -1,    -1,    91,    92,    39,    40,
    41,    42,    43,    44,    -1,    46,    47,    48,    49,    -1,
    -1,    -1,    -1,    54,    -1,    -1,    57,    -1,    -1,    60,
    61,    62,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
    81,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
    91,    92,    39,    40,    41,    42,    43,    44,    -1,    46,
    47,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,
    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    82,    83,    84,    85,    -1,
    -1,    -1,    -1,    -1,    91,    92,    39,    40,    41,    42,
    43,    44,    -1,    46,    47,    48,    49,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,    62,
    -1,    -1,    -1,    66,    67,    39,    40,    41,    42,    43,
    44,    -1,    46,    47,    48,    49,    79,    80,    81,    82,
    83,    -1,    85,    57,    -1,    -1,    60,    61,    62,    92,
    -1,    -1,    66,    67,    39,    40,    41,    42,    43,    44,
    -1,    46,    -1,    48,    49,    79,    80,    81,    82,    -1,
    -1,    85,    57,    -1,    -1,    60,    61,    62,    92,    -1,
    -1,    66,    67,    39,    40,    41,    42,    43,    44,    -1,
    46,    -1,    48,    49,    79,    80,    81,    82,    -1,    -1,
    85,    -1,    -1,    -1,    60,    61,    62,    92,    -1,    -1,
    66,    67,    39,    40,    41,    42,    43,    44,    -1,    46,
    -1,    -1,    49,    79,    80,    81,    82,    -1,    -1,    85,
    -1,    -1,    -1,    60,    61,    62,    92,    -1,    -1,    66,
    67,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    82,    -1,    -1,    85,    45,
    -1,    63,    64,    -1,    -1,    92,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    -1,    63,    64,    -1,
    -1,    -1,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    39,    40,    41,    42,    -1,    -1,    -1,    46,
    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
    67
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 192 "bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#else
#define YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#endif

int
yyparse(YYPARSE_PARAM)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror((char*)"parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 146 "cmdgram.y"
{ ;
    break;}
case 2:
#line 151 "cmdgram.y"
{ yyval.stmt = nil; ;
    break;}
case 3:
#line 153 "cmdgram.y"
{ if(!statementList) { statementList = yyvsp[0].stmt; } else { statementList->append(yyvsp[0].stmt); } ;
    break;}
case 4:
#line 158 "cmdgram.y"
{ yyval.stmt = yyvsp[0].stmt; ;
    break;}
case 5:
#line 160 "cmdgram.y"
{ yyval.stmt = yyvsp[0].stmt; ;
    break;}
case 6:
#line 162 "cmdgram.y"
{ yyval.stmt = yyvsp[0].stmt; ;
    break;}
case 7:
#line 167 "cmdgram.y"
{ yyval.stmt = yyvsp[-2].stmt; for(StmtNode *walk = (yyvsp[-2].stmt);walk;walk = walk->getNext() ) walk->setPackage(yyvsp[-4].s); ;
    break;}
case 8:
#line 172 "cmdgram.y"
{ yyval.stmt = yyvsp[0].stmt; ;
    break;}
case 9:
#line 174 "cmdgram.y"
{ yyval.stmt = yyvsp[-1].stmt; (yyvsp[-1].stmt)->append(yyvsp[0].stmt);  ;
    break;}
case 10:
#line 179 "cmdgram.y"
{ yyval.stmt = nil; ;
    break;}
case 11:
#line 181 "cmdgram.y"
{ if(!yyvsp[-1].stmt) { yyval.stmt = yyvsp[0].stmt; } else { (yyvsp[-1].stmt)->append(yyvsp[0].stmt); yyval.stmt = yyvsp[-1].stmt; } ;
    break;}
case 17:
#line 191 "cmdgram.y"
{ yyval.stmt = BreakStmtNode::alloc(); ;
    break;}
case 18:
#line 193 "cmdgram.y"
{ yyval.stmt = ContinueStmtNode::alloc(); ;
    break;}
case 19:
#line 195 "cmdgram.y"
{ yyval.stmt = ReturnStmtNode::alloc(NULL); ;
    break;}
case 20:
#line 197 "cmdgram.y"
{ yyval.stmt = ReturnStmtNode::alloc(yyvsp[-1].expr); ;
    break;}
case 21:
#line 199 "cmdgram.y"
{ yyval.stmt = yyvsp[-1].stmt; ;
    break;}
case 22:
#line 201 "cmdgram.y"
{ yyval.stmt = TTagSetStmtNode::alloc(yyvsp[-3].s, yyvsp[-1].expr, NULL); ;
    break;}
case 23:
#line 203 "cmdgram.y"
{ yyval.stmt = TTagSetStmtNode::alloc(yyvsp[-5].s, yyvsp[-3].expr, yyvsp[-1].expr); ;
    break;}
case 24:
#line 205 "cmdgram.y"
{ yyval.stmt = StrConstNode::alloc(yyvsp[0].str, false, true); ;
    break;}
case 25:
#line 210 "cmdgram.y"
{ yyval.stmt = FunctionDeclStmtNode::alloc(yyvsp[-6].s, NULL, yyvsp[-4].var, yyvsp[-1].stmt); ;
    break;}
case 26:
#line 212 "cmdgram.y"
{ yyval.stmt = FunctionDeclStmtNode::alloc(yyvsp[-6].s, yyvsp[-8].s, yyvsp[-4].var, yyvsp[-1].stmt); ;
    break;}
case 27:
#line 217 "cmdgram.y"
{ yyval.var = NULL; ;
    break;}
case 28:
#line 219 "cmdgram.y"
{ yyval.var = yyvsp[0].var; ;
    break;}
case 29:
#line 224 "cmdgram.y"
{ yyval.var = VarNode::alloc(yyvsp[0].s, NULL); ;
    break;}
case 30:
#line 226 "cmdgram.y"
{ yyval.var = yyvsp[-2].var; ((StmtNode*)(yyvsp[-2].var))->append((StmtNode*)VarNode::alloc(yyvsp[0].s, NULL)); ;
    break;}
case 31:
#line 231 "cmdgram.y"
{ yyval.stmt = ObjectDeclNode::alloc(ConstantNode::alloc(yyvsp[-8].s), ConstantNode::alloc(yyvsp[-6].s), NULL, yyvsp[-5].s, yyvsp[-2].slist, NULL, true, false, false); ;
    break;}
case 32:
#line 236 "cmdgram.y"
{ yyval.od = ObjectDeclNode::alloc(yyvsp[-7].expr, yyvsp[-5].expr, NULL, yyvsp[-4].s, yyvsp[-1].odcl.slots, yyvsp[-1].odcl.decls, false, false, true); ;
    break;}
case 33:
#line 238 "cmdgram.y"
{ yyval.od = ObjectDeclNode::alloc(yyvsp[-4].expr, yyvsp[-2].expr, NULL, yyvsp[-1].s, NULL, NULL, false, false, true); ;
    break;}
case 34:
#line 243 "cmdgram.y"
{ yyval.od = ObjectDeclNode::alloc(yyvsp[-8].expr, yyvsp[-6].expr, yyvsp[-4].expr, yyvsp[-5].s, yyvsp[-1].odcl.slots, yyvsp[-1].odcl.decls, false, false, false); ;
    break;}
case 35:
#line 245 "cmdgram.y"
{ yyval.od = ObjectDeclNode::alloc(yyvsp[-5].expr, yyvsp[-3].expr, yyvsp[-1].expr, yyvsp[-2].s, NULL, NULL, false, false, false); ;
    break;}
case 36:
#line 247 "cmdgram.y"
{ yyval.od = ObjectDeclNode::alloc(yyvsp[-10].expr, yyvsp[-7].expr, yyvsp[-4].expr, yyvsp[-5].s, yyvsp[-1].odcl.slots, yyvsp[-1].odcl.decls, false, true, false); ;
    break;}
case 37:
#line 249 "cmdgram.y"
{ yyval.od = ObjectDeclNode::alloc(yyvsp[-7].expr, yyvsp[-4].expr, yyvsp[-1].expr, yyvsp[-2].s, NULL, NULL, false, true, false); ;
    break;}
case 38:
#line 254 "cmdgram.y"
{ yyval.s = NULL; ;
    break;}
case 39:
#line 256 "cmdgram.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 40:
#line 261 "cmdgram.y"
{ yyval.expr = StrConstNode::alloc((char*)"", false); ;
    break;}
case 41:
#line 263 "cmdgram.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 42:
#line 268 "cmdgram.y"
{ yyval.expr = NULL; ;
    break;}
case 43:
#line 270 "cmdgram.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 44:
#line 275 "cmdgram.y"
{ yyval.odcl.slots = NULL; yyval.odcl.decls = NULL; ;
    break;}
case 45:
#line 277 "cmdgram.y"
{ yyval.odcl.slots = yyvsp[0].slist; yyval.odcl.decls = NULL; ;
    break;}
case 46:
#line 282 "cmdgram.y"
{ yyval.odcl.slots = NULL; yyval.odcl.decls = NULL; ;
    break;}
case 47:
#line 284 "cmdgram.y"
{ yyval.odcl.slots = yyvsp[0].slist; yyval.odcl.decls = NULL; ;
    break;}
case 48:
#line 286 "cmdgram.y"
{ yyval.odcl.slots = NULL; yyval.odcl.decls = yyvsp[0].od; ;
    break;}
case 49:
#line 288 "cmdgram.y"
{ yyval.odcl.slots = yyvsp[-1].slist; yyval.odcl.decls = yyvsp[0].od; ;
    break;}
case 50:
#line 293 "cmdgram.y"
{ yyval.od = yyvsp[-1].od; ;
    break;}
case 51:
#line 295 "cmdgram.y"
{ yyvsp[-2].od->append(yyvsp[-1].od); yyval.od = yyvsp[-2].od; ;
    break;}
case 52:
#line 300 "cmdgram.y"
{ yyval.stmt = yyvsp[-1].stmt; ;
    break;}
case 53:
#line 302 "cmdgram.y"
{ yyval.stmt = yyvsp[0].stmt; ;
    break;}
case 54:
#line 307 "cmdgram.y"
{ yyval.stmt = yyvsp[-1].ifnode; yyvsp[-1].ifnode->propagateSwitchExpr(yyvsp[-4].expr, false); ;
    break;}
case 55:
#line 309 "cmdgram.y"
{ yyval.stmt = yyvsp[-1].ifnode; yyvsp[-1].ifnode->propagateSwitchExpr(yyvsp[-4].expr, true); ;
    break;}
case 56:
#line 314 "cmdgram.y"
{ yyval.ifnode = IfStmtNode::alloc(yyvsp[-3].i, yyvsp[-2].expr, yyvsp[0].stmt, NULL, false); ;
    break;}
case 57:
#line 316 "cmdgram.y"
{ yyval.ifnode = IfStmtNode::alloc(yyvsp[-6].i, yyvsp[-5].expr, yyvsp[-3].stmt, yyvsp[0].stmt, false); ;
    break;}
case 58:
#line 318 "cmdgram.y"
{ yyval.ifnode = IfStmtNode::alloc(yyvsp[-4].i, yyvsp[-3].expr, yyvsp[-1].stmt, yyvsp[0].ifnode, true); ;
    break;}
case 59:
#line 323 "cmdgram.y"
{ yyval.expr = yyvsp[0].expr;;
    break;}
case 60:
#line 325 "cmdgram.y"
{ (yyvsp[-2].expr)->append(yyvsp[0].expr); yyval.expr=yyvsp[-2].expr; ;
    break;}
case 61:
#line 330 "cmdgram.y"
{ yyval.stmt = IfStmtNode::alloc(yyvsp[-4].i, yyvsp[-2].expr, yyvsp[0].stmt, NULL, false); ;
    break;}
case 62:
#line 332 "cmdgram.y"
{ yyval.stmt = IfStmtNode::alloc(yyvsp[-6].i, yyvsp[-4].expr, yyvsp[-2].stmt, yyvsp[0].stmt, false); ;
    break;}
case 63:
#line 337 "cmdgram.y"
{ yyval.stmt = LoopStmtNode::alloc(yyvsp[-4].i, nil, yyvsp[-2].expr, nil, yyvsp[0].stmt, false); ;
    break;}
case 64:
#line 339 "cmdgram.y"
{ yyval.stmt = LoopStmtNode::alloc(yyvsp[-3].i, nil, yyvsp[-1].expr, nil, yyvsp[-4].stmt, true); ;
    break;}
case 65:
#line 344 "cmdgram.y"
{ yyval.stmt = LoopStmtNode::alloc(yyvsp[-8].i, yyvsp[-6].expr, yyvsp[-4].expr, yyvsp[-2].expr, yyvsp[0].stmt, false); ;
    break;}
case 66:
#line 346 "cmdgram.y"
{ yyval.stmt = LoopStmtNode::alloc(yyvsp[-7].i, yyvsp[-5].expr, yyvsp[-3].expr, NULL, yyvsp[0].stmt, false); ;
    break;}
case 67:
#line 348 "cmdgram.y"
{ yyval.stmt = LoopStmtNode::alloc(yyvsp[-7].i, yyvsp[-5].expr, NULL, yyvsp[-2].expr, yyvsp[0].stmt, false); ;
    break;}
case 68:
#line 350 "cmdgram.y"
{ yyval.stmt = LoopStmtNode::alloc(yyvsp[-6].i, yyvsp[-4].expr, NULL, NULL, yyvsp[0].stmt, false); ;
    break;}
case 69:
#line 352 "cmdgram.y"
{ yyval.stmt = LoopStmtNode::alloc(yyvsp[-7].i, NULL, yyvsp[-4].expr, yyvsp[-2].expr, yyvsp[0].stmt, false); ;
    break;}
case 70:
#line 354 "cmdgram.y"
{ yyval.stmt = LoopStmtNode::alloc(yyvsp[-6].i, NULL, yyvsp[-3].expr, NULL, yyvsp[0].stmt, false); ;
    break;}
case 71:
#line 356 "cmdgram.y"
{ yyval.stmt = LoopStmtNode::alloc(yyvsp[-6].i, NULL, NULL, yyvsp[-2].expr, yyvsp[0].stmt, false); ;
    break;}
case 72:
#line 358 "cmdgram.y"
{ yyval.stmt = LoopStmtNode::alloc(yyvsp[-5].i, NULL, NULL, NULL, yyvsp[0].stmt, false); ;
    break;}
case 73:
#line 363 "cmdgram.y"
{ yyval.stmt = yyvsp[0].expr; ;
    break;}
case 74:
#line 368 "cmdgram.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 75:
#line 370 "cmdgram.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 76:
#line 372 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 77:
#line 374 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 78:
#line 376 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 79:
#line 378 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 80:
#line 380 "cmdgram.y"
{ yyval.expr = FloatBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 81:
#line 382 "cmdgram.y"
{ yyval.expr = FloatBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 82:
#line 384 "cmdgram.y"
{ yyval.expr = FloatBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 83:
#line 386 "cmdgram.y"
{ yyval.expr = FloatBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 84:
#line 388 "cmdgram.y"
{ yyval.expr = FloatUnaryExprNode::alloc(yyvsp[-1].i, yyvsp[0].expr); ;
    break;}
case 85:
#line 390 "cmdgram.y"
{ yyval.expr = TTagDerefNode::alloc(yyvsp[0].expr); ;
    break;}
case 86:
#line 392 "cmdgram.y"
{ yyval.expr = TTagExprNode::alloc(yyvsp[0].s); ;
    break;}
case 87:
#line 394 "cmdgram.y"
{ yyval.expr = ConditionalExprNode::alloc(yyvsp[-4].expr, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 88:
#line 396 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 89:
#line 398 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 90:
#line 400 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 91:
#line 402 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 92:
#line 404 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 93:
#line 406 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 94:
#line 408 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 95:
#line 410 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 96:
#line 412 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 97:
#line 414 "cmdgram.y"
{ yyval.expr = IntBinaryExprNode::alloc(yyvsp[-1].i, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 98:
#line 416 "cmdgram.y"
{ yyval.expr = StreqExprNode::alloc(yyvsp[-2].expr, yyvsp[0].expr, true); ;
    break;}
case 99:
#line 418 "cmdgram.y"
{ yyval.expr = StreqExprNode::alloc(yyvsp[-2].expr, yyvsp[0].expr, false); ;
    break;}
case 100:
#line 420 "cmdgram.y"
{ yyval.expr = StrcatExprNode::alloc(yyvsp[-2].expr, yyvsp[0].expr, yyvsp[-1].i); ;
    break;}
case 101:
#line 422 "cmdgram.y"
{ yyval.expr = IntUnaryExprNode::alloc(yyvsp[-1].i, yyvsp[0].expr); ;
    break;}
case 102:
#line 424 "cmdgram.y"
{ yyval.expr = IntUnaryExprNode::alloc(yyvsp[-1].i, yyvsp[0].expr); ;
    break;}
case 103:
#line 426 "cmdgram.y"
{ yyval.expr = StrConstNode::alloc(yyvsp[0].str, true); ;
    break;}
case 104:
#line 428 "cmdgram.y"
{ yyval.expr = FloatNode::alloc(yyvsp[0].f); ;
    break;}
case 105:
#line 430 "cmdgram.y"
{ yyval.expr = IntNode::alloc(yyvsp[0].i); ;
    break;}
case 106:
#line 432 "cmdgram.y"
{ yyval.expr = ConstantNode::alloc(StringTable->insert("break")); ;
    break;}
case 107:
#line 434 "cmdgram.y"
{ yyval.expr = SlotAccessNode::alloc(yyvsp[0].slot.object, yyvsp[0].slot.array, yyvsp[0].slot.slotName); ;
    break;}
case 108:
#line 436 "cmdgram.y"
{ yyval.expr = InternalSlotAccessNode::alloc(yyvsp[0].intslot.object, yyvsp[0].intslot.slotExpr, yyvsp[0].intslot.recurse); ;
    break;}
case 109:
#line 438 "cmdgram.y"
{ yyval.expr = ConstantNode::alloc(yyvsp[0].s); ;
    break;}
case 110:
#line 440 "cmdgram.y"
{ yyval.expr = StrConstNode::alloc(yyvsp[0].str, false); ;
    break;}
case 111:
#line 442 "cmdgram.y"
{ yyval.expr = (ExprNode*)VarNode::alloc(yyvsp[0].s, NULL); ;
    break;}
case 112:
#line 444 "cmdgram.y"
{ yyval.expr = (ExprNode*)VarNode::alloc(yyvsp[-3].s, yyvsp[-1].expr); ;
    break;}
case 113:
#line 449 "cmdgram.y"
{ yyval.slot.object = yyvsp[-2].expr; yyval.slot.slotName = yyvsp[0].s; yyval.slot.array = NULL; ;
    break;}
case 114:
#line 451 "cmdgram.y"
{ yyval.slot.object = yyvsp[-5].expr; yyval.slot.slotName = yyvsp[-3].s; yyval.slot.array = yyvsp[-1].expr; ;
    break;}
case 115:
#line 456 "cmdgram.y"
{ yyval.intslot.object = yyvsp[-2].expr; yyval.intslot.slotExpr = yyvsp[0].expr; yyval.intslot.recurse = false; ;
    break;}
case 116:
#line 458 "cmdgram.y"
{ yyval.intslot.object = yyvsp[-2].expr; yyval.intslot.slotExpr = yyvsp[0].expr; yyval.intslot.recurse = true; ;
    break;}
case 117:
#line 463 "cmdgram.y"
{ yyval.expr = ConstantNode::alloc(yyvsp[0].s); ;
    break;}
case 118:
#line 465 "cmdgram.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 119:
#line 470 "cmdgram.y"
{ yyval.asn.token = '+'; yyval.asn.expr = FloatNode::alloc(1); ;
    break;}
case 120:
#line 472 "cmdgram.y"
{ yyval.asn.token = '-'; yyval.asn.expr = FloatNode::alloc(1); ;
    break;}
case 121:
#line 474 "cmdgram.y"
{ yyval.asn.token = '+'; yyval.asn.expr = yyvsp[0].expr; ;
    break;}
case 122:
#line 476 "cmdgram.y"
{ yyval.asn.token = '-'; yyval.asn.expr = yyvsp[0].expr; ;
    break;}
case 123:
#line 478 "cmdgram.y"
{ yyval.asn.token = '*'; yyval.asn.expr = yyvsp[0].expr; ;
    break;}
case 124:
#line 480 "cmdgram.y"
{ yyval.asn.token = '/'; yyval.asn.expr = yyvsp[0].expr; ;
    break;}
case 125:
#line 482 "cmdgram.y"
{ yyval.asn.token = '%'; yyval.asn.expr = yyvsp[0].expr; ;
    break;}
case 126:
#line 484 "cmdgram.y"
{ yyval.asn.token = '&'; yyval.asn.expr = yyvsp[0].expr; ;
    break;}
case 127:
#line 486 "cmdgram.y"
{ yyval.asn.token = '^'; yyval.asn.expr = yyvsp[0].expr; ;
    break;}
case 128:
#line 488 "cmdgram.y"
{ yyval.asn.token = '|'; yyval.asn.expr = yyvsp[0].expr; ;
    break;}
case 129:
#line 490 "cmdgram.y"
{ yyval.asn.token = opSHL; yyval.asn.expr = yyvsp[0].expr; ;
    break;}
case 130:
#line 492 "cmdgram.y"
{ yyval.asn.token = opSHR; yyval.asn.expr = yyvsp[0].expr; ;
    break;}
case 131:
#line 497 "cmdgram.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 132:
#line 499 "cmdgram.y"
{ yyval.expr = yyvsp[0].od; ;
    break;}
case 133:
#line 501 "cmdgram.y"
{ yyval.expr = yyvsp[0].od; ;
    break;}
case 134:
#line 503 "cmdgram.y"
{ yyval.expr = AssignExprNode::alloc(yyvsp[-2].s, NULL, yyvsp[0].expr); ;
    break;}
case 135:
#line 505 "cmdgram.y"
{ yyval.expr = AssignExprNode::alloc(yyvsp[-5].s, yyvsp[-3].expr, yyvsp[0].expr); ;
    break;}
case 136:
#line 507 "cmdgram.y"
{ yyval.expr = AssignOpExprNode::alloc(yyvsp[-1].s, NULL, yyvsp[0].asn.expr, yyvsp[0].asn.token); ;
    break;}
case 137:
#line 509 "cmdgram.y"
{ yyval.expr = AssignOpExprNode::alloc(yyvsp[-4].s, yyvsp[-2].expr, yyvsp[0].asn.expr, yyvsp[0].asn.token); ;
    break;}
case 138:
#line 511 "cmdgram.y"
{ yyval.expr = SlotAssignOpNode::alloc(yyvsp[-1].slot.object, yyvsp[-1].slot.slotName, yyvsp[-1].slot.array, yyvsp[0].asn.token, yyvsp[0].asn.expr); ;
    break;}
case 139:
#line 513 "cmdgram.y"
{ yyval.expr = SlotAssignNode::alloc(yyvsp[-2].slot.object, yyvsp[-2].slot.array, yyvsp[-2].slot.slotName, yyvsp[0].expr); ;
    break;}
case 140:
#line 515 "cmdgram.y"
{ yyval.expr = SlotAssignNode::alloc(yyvsp[-4].slot.object, yyvsp[-4].slot.array, yyvsp[-4].slot.slotName, yyvsp[-1].expr); ;
    break;}
case 141:
#line 520 "cmdgram.y"
{ yyval.expr = FuncCallExprNode::alloc(yyvsp[-3].s, NULL, yyvsp[-1].expr, false); ;
    break;}
case 142:
#line 522 "cmdgram.y"
{ yyval.expr = FuncCallExprNode::alloc(yyvsp[-3].s, yyvsp[-5].s, yyvsp[-1].expr, false); ;
    break;}
case 143:
#line 524 "cmdgram.y"
{ yyvsp[-5].expr->append(yyvsp[-1].expr); yyval.expr = FuncCallExprNode::alloc(yyvsp[-3].s, NULL, yyvsp[-5].expr, true); ;
    break;}
case 144:
#line 529 "cmdgram.y"
{ yyval.expr = NULL; ;
    break;}
case 145:
#line 531 "cmdgram.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 146:
#line 536 "cmdgram.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 147:
#line 538 "cmdgram.y"
{ (yyvsp[-2].expr)->append(yyvsp[0].expr); yyval.expr = yyvsp[-2].expr; ;
    break;}
case 148:
#line 543 "cmdgram.y"
{ yyval.slist = yyvsp[0].slist; ;
    break;}
case 149:
#line 545 "cmdgram.y"
{ yyvsp[-1].slist->append(yyvsp[0].slist); yyval.slist = yyvsp[-1].slist; ;
    break;}
case 150:
#line 550 "cmdgram.y"
{ yyval.slist = SlotAssignNode::alloc(NULL, NULL, yyvsp[-3].s, yyvsp[-1].expr); ;
    break;}
case 151:
#line 552 "cmdgram.y"
{ yyval.slist = SlotAssignNode::alloc(NULL, NULL, StringTable->insert("datablock"), yyvsp[-1].expr); ;
    break;}
case 152:
#line 554 "cmdgram.y"
{ yyval.slist = SlotAssignNode::alloc(NULL, yyvsp[-4].expr, yyvsp[-6].s, yyvsp[-1].expr); ;
    break;}
case 153:
#line 559 "cmdgram.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 154:
#line 561 "cmdgram.y"
{ yyval.expr = CommaCatExprNode::alloc(yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 487 "bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror((char*)"parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 563 "cmdgram.y"


